-- mrp name resolver

local Main = ListenerAddon
local L = Main.Locale

local function TryGet( name )
	if msp.char[name] and msp.char[name].supported 
	   and mrp.DisplayChat.NA( msp.char[name].field.NA ) ~= "" then
		
		local icname = msp.char[name].field.NA
		local color = icname:match( "^|c([0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F])" )
		local namesplit = mrp.DisplayChat.NA( msp.char[name].field.NA ):gmatch( "%S+" )
		
		return namesplit(), namesplit(), color
	end
end
 
-------------------------------------------------------------------------------
local function Resolve( name, guid )
	local firstname, lastname, color
	
	local fullname = name
	if not name:find( "-" ) then
		local n,r = UnitFullName( "player" )
		fullname = name .. "-" .. r
	end
	
	firstname, lastname, color = TryGet( fullname )
	if firstname then
		return firstname, lastname, nil, color
	end
	
	if fullname ~= name then
		firstname, lastname, color = TryGet( name )
		if firstname then
			return firstname, lastname, nil, color
		end
	end
  
	return name
end

-- check again after everything loads
local function Init()
	if mrp then
		Main:SetNameResolver( Resolve )
	end
end

Init()
Main:AddLoadCall( Init )
