-- xrp name resolver

local Main = ListenerAddon
local L = Main.Locale
 
-------------------------------------------------------------------------------
local function Resolve( name, guid )
	local color = nil
	
	local ch = xrp.characters.byGUID[ guid ]
	
	if ch and not ch.hide then
		local icname = ch.fields.NA or name
		
		-- get trp color code
		color = icname:match( "^|c([0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F])" )
		icname = xrp.Strip( icname )
		local a = icname:gmatch( "%S+" )
		
		return a(), a(), nil, color
	end
	
	return name
end

-- check again after everything loads
local function Init()
	if xrp then
		Main:SetNameResolver( Resolve )
	end
end

Init()
Main:AddLoadCall( Init ) -- check again after everything loads
